#!/bin/bash

#export QT_SCALE_FACTOR=1.2

#reso=$(xrandr | grep -m1 "*+" | awk '{ print $1 }' | cut -c -4)
#reso=$(fbset -s | grep geometry | awk '{print $2}')
#if [ "$reso" -ge 3840 ]; then
#    export QT_AUTO_SCREEN_SET_FACTOR=0
#    export QT_SCALE_FACTOR=2
#    export QT_FONT_DPI=192
#else
#    if [ "$reso" -ge 2048 ]; then
#	export QT_AUTO_SCREEN_SET_FACTOR=0
#	export QT_SCALE_FACTOR=1.3
#	export QT_FONT_DPI=144
#    fi
#fi

crypt=""
efi=""
space=""
partcount=""
fastboot=""
bitlock=""
echo "" >/tmp/fastboot
echo "" >/tmp/bitlock

#some hacks
systemctl stop packagekit.service
killall -9 DiscoverNotifier

#if [ "${XDG_SESSION_TYPE}" = "wayland" ]; then
#    cp -f /usr/share/tuxedo/packagechooserq@session.qml /etc/calamares/branding/tuxedo/
#    sed -i 's/kwin-x11/kwin-waylamd/' /etc/calamares/modules/session.conf
#else
#    cp -f /usr/share/tuxedo/packagechooserq@xsession.qml /etc/calamares/branding/tuxedo/packagechooserq@session.qml
#    sed -i 's/kwin-waylamd/kwin-x11/' /etc/calamares/modules/session.conf
#fi
cp -f /usr/share/tuxedo/oem-conf/main.py /usr/lib/x86_64-linux-gnu/calamares/modules/session
#end some hacks



for i in $(lsblk -lf -o NAME,FSTYPE | awk '/ntfs/{print $1}'); do ntfs-3g.probe --readwrite /dev/$i; done &> /tmp/fastboot
lsblk -lf -o NAME,FSTYPE | grep -i bitlock | awk '{print $1}' &> /tmp/bitlock


#DEFLOCDIR=/home/towo/test/
DEFLOCDIR=/usr/share/tuxedo/oem-conf/

llang=$(echo $LANG | awk -F\_ '{print $1}')

case $llang in
    de*)
	. $DEFLOCDIR/text_de
        ;;
    *)
	. $DEFLOCDIR/text_en
	export LANG=C
        ;;
esac

calamares
exit 0

check_memory() {
    mem=$(LANG=C free -m | awk '/Mem/{ print $2 }')
    mem_g=$(echo "$mem/1024+1" | bc)
    mem_d=$(echo "$mem_g+20" | bc)
}

check_fastboot() {
    if [ $(awk '/hibernate/{print $1}' /tmp/fastboot) ]; then
	fastboot=fastboot
    else
	fastboot=""
    fi
}

check_bitlock() {
    if [ "$(cat /tmp/bitlock)" ]; then
	bitlock=lock
    else
	bitlock=""
    fi
}

check_crypt() {
    kdialog --title "$title2" --yesnocancel "<p>$text_cr1</p>" "<p>$text_crd1${mem_d}$text_crd2</p>" --yes-label "$cr_ja" --no-label "$cr_nein"
    case $? in
	0)
	    crypt="crypt"
	    ;;
	1)
	    calamares
	    exit 0
	    ;;
	*)
	    exit 0
	    ;;
    esac
}

check_efi() {
if [ -e /sys/firmware/efi ]; then
    efi="efi"
else
    calamares
    exit 0
fi
}

find_device() {
    echo "" > /tmp/disklist.txt
    for x in $(lsblk -dnl -o NAME,RM | grep -E -v " 1|loop" | awk '{print $1}'); do lsblk -lfo NAME,FSTYPE | grep $x > /tmp/disk_$x.txt; done
    for liste in /tmp/disk_*; do cat $liste >> /tmp/disklist.txt; done
    for i in $(lsblk -dn -o NAME,TYPE,SUBSYSTEMS | grep -E -iv "loop|rom|usb" | awk '{print$1}'); do
	z=$(lsblk -dn -o NAME,Size | grep $i | awk '{print $2}')
	echo -e  $i'\t'\'$i'\t'$z'\t'$(cat /sys/block/$i/device/model | sed 's/*_//')\' | sed "s/\ '/\'/g"
    done 1> /tmp/device1 2> /dev/null
    cat /tmp/device1 | sort 1> /tmp/device 2> /dev/null
    if [ "$(cat /tmp/device | wc -l)" -ge 2 ]; then
        device=$(dialog_disk.pl)
    else
        device=$(cat /tmp/device | awk '{print $1}')
    fi
    if [ -z "$device" ]; then
	kdialog --sorry "$text1"
	exit 0
    fi
    echo $device
}

find_biggest() {
    disk="/dev/${device}"
    lsblk_output=$(lsblk -lbno NAME,SIZE "$disk" | tail -n +2)

    largest_partition=""
    largest_size=0

    # Schleife durch die Partitionen und finde die größte
    while read -r partition size; do
        size_in_bytes=$((size))
        if ((size_in_bytes > largest_size)); then
            largest_size=$size_in_bytes
            largest_partition=$partition
        fi
    done <<< "$lsblk_output"

    # Ausgabe der größten Partition
    echo "Die größte Partition: $largest_partition"
    number="${largest_partition: -1}"
}

check_free() {
    if [ "$(LANG=C parted /dev/$device unit MiB print free | grep Free | awk '{print $3}' | sort | tail -1 | awk -F\, '{print $1}' | awk -F\. '{print $1}' | sed 's/MiB//')" -ge 20480 ]; then
        space=$(LANG=C parted /dev/$device unit MiB print free | grep Free | awk '{print $3}' | sort | tail -1 | sed 's/MiB//')
        spaceg=$(echo "${space}/1024" | bc)
        min_size=$(echo "${spaceg}+16" | bc)
        echo $space
    else
        space=""
    fi
}

count_part() {
    parts=$(LANG=C blkid -c /dev/null | grep "$device" | awk -F\: '{print $1}' | sort | wc -l 2>/dev/null)
#    echo $parts
}

generate_sizes() {
    find_biggest
    start=$(LANG=C parted /dev/$device unit MiB print free | grep MiB | grep -v Disk | grep "$space" | awk '{print $1}' | sed 's/MiB//')    
    start1=$(echo "${start}+1" | bc)
    start2=$(echo "${start1}+2048" | bc)
    start3=$(echo "${start2}+512" | bc)
    pnum1=$(echo "${parts}+1" | bc)
    pnum2=$(echo "${pnum1}+1" | bc)
    pnum3=$(echo "${pnum2}+1" | bc)
    crypt_part_sizem=$(echo "${space}-2562" | bc)
    crypt_part_sizeg=$(echo "${crypt_part_sizem}/1024" | bc)
    root_part_size=$(echo "${crypt_part_sizeg}" | bc)
}

size_fd() {
    parts=0
    pnum1=$(echo "${parts}+1" | bc)
    pnum2=$(echo "${pnum1}+1" | bc)
    pnum3=$(echo "${pnum2}+1" | bc)
    crypt_part_size=$(parted /dev/$device unit MiB print | grep ${device} | awk '{print $3}' | sed 's/MiB//')
    crypt_part_sizem=$(echo "${crypt_part_size}-2562" | bc)
    crypt_part_sizeg=$(echo "${crypt_part_sizem}/1024" | bc)
    root_part_size=$(echo "${crypt_part_sizeg}" | bc)
}

luks_passwd() {
    ERC=1
    until [ $ERC -ne 1 ]
    do
    if ! CPASSW1=$(kdialog --title="$title_pw" --password "$text_pw1" 2>/dev/null); then
        kdialog --error "$text_pw4" 2>/dev/null
        exit 0;
    fi
    if ! CPASSW2=$(kdialog --title="$title_pw" --password "$text_pw2" 2>/dev/null); then
        kdialog --error "$text_pw4" 2>/dev/null
        exit 0;
    fi
    sleep 1
    if [ "$CPASSW1" == "$CPASSW2" ]; then
        set +H
        ERC=0
        lukspw=${CPASSW1}
        break;
    else
        ERC=1
        kdialog --error "$text_pw3" 2>/dev/null
    fi
    done
}

prepare_disk_full() {
    nvme=$(echo $device | grep nvm)
    if [ "$nvme" ]; then
        part="p"
    else
        part=""
    fi
    parted --script /dev/${device} \
          mklabel gpt \
          mkpart primary ext3 1MiB 2049MiB \
          mkpart primary fat32 2049MiB 2561MiB \
          mkpart primary 2561MiB 100% \
          name ${pnum1} BOOT \
          name ${pnum2} EFI \
          name ${pnum3} CRYPT \
          set ${pnum2} esp on \
          print \
          quit 

    echo ${lukspw} | cryptsetup -q luksFormat /dev/${device}${part}${pnum3}
    echo ${lukspw} | cryptsetup -q luksOpen /dev/${device}${part}${pnum3} crypt_dev_${device}${part}${pnum3}
    pvcreate /dev/mapper/crypt_dev_${device}${part}${pnum3}
    vgcreate system /dev/mapper/crypt_dev_${device}${part}${pnum3}
    lvcreate -n root -l 100%FREE system
    echo ${device}${part}${pnum1}
    echo ${device}${part}${pnum2}
    mkfs.$fs /dev/system/root
    mkfs.ext3 /dev/${device}${part}${pnum1} -L BOOT<<EOF
y
EOF
    mkfs.vfat /dev/${device}${part}${pnum2} -n EFI
}

prepare_disk_along() {
    count_part
    generate_sizes
    nvme=$(echo $device | grep nvm)
    if [ "$nvme" ]; then
	part="p"
    else
	part=""
    fi
    parted --script /dev/${device} \
         mkpart primary ext3 ${start1}MiB ${start2}MiB \
         mkpart primary fat32 ${start2}MiB ${start3}MiB \
         mkpart primary ${start3}MiB 100% \
         name ${pnum1} BOOT \
         name ${pnum2} EFI \
         name ${pnum3} CRYPT \
         set ${pnum2} esp on \
         print \
         quit

    echo ${lukspw} | cryptsetup -q luksFormat /dev/${device}${part}${pnum3}
    echo ${lukspw} | cryptsetup -q luksOpen /dev/${device}${part}${pnum3} crypt_dev_${device}${part}${pnum3}
    pvcreate /dev/mapper/crypt_dev_${device}${part}${pnum3}
    vgcreate system /dev/mapper/crypt_dev_${device}${part}${pnum3}
    lvcreate -n root -l 100%FREE system
    echo ${device}${part}${pnum1}
    echo ${device}${part}${pnum2}
    mkfs.$fs /dev/system/root
    mkfs.ext3 /dev/${device}${part}${pnum1} -L BOOT<<EOF
y
EOF
    mkfs.vfat /dev/${device}${part}${pnum2} -n EFI
}

use_full() {
    kdialog --title "$title_fd" --yesnocancel "$text_fd" "Disk:&nbsp;&nbsp; $device<pre>$(LANG=C parted /dev/${device} unit GiB print free|tail -n +6)</pre>" --yes-label "$pn" --no-label "$nein2"
    case $? in
	0)
	    fd_install="1"
	    parts=0
	    ;;
	1)
	    fd_install=""
	    ;;
	*)
	    exit 0
	    ;;
    esac
}

rsync_task() {
    rsync -aAXv / --exclude={"/dev/*","/proc/*","/sys/*","/tmp/*","/run/*","/mnt/*","/media/*","/lost+found","/boot/efi","/fll"} /mnt
}

check_mounts() {
    mounted=$(mount | grep "system-root" | awk '{print $5}' 2>/dev/null)
    if [ -z ${mounted} ]; then
        kdialog --error "$text_mount" 2>/dev/null
        exit 1
    fi
}

prepare_target() {
    nvme=$(echo $device | grep nvm)
    if [ "$nvme" ]; then
        part="p"
    else
        part=""
    fi
    if [ "$fs" = btrfs ]; then
	mount -t $fs /dev/system/root /mnt -o defaults,noatime,space_cache=v2,autodefrag,compress=zstd:11
    else
	mount -t $fs /dev/system/root /mnt
    fi
    mkdir -p /mnt/boot
    mount /dev/${device}${part}${pnum1} /mnt/boot
}

calamares_task() {
    nvme=$(echo $device | grep nvm)
    if [ "$nvme" ]; then
        part="p"
    else
        part=""
    fi
    mkdir -p /mnt/boot/efi
    mount /dev/${device}${part}${pnum2} /mnt/boot/efi
    for d in /dev /dev/pts /proc /sys /sys/firmware/efi/efivars /run; do sudo mount -B $d /mnt$d; done
    chroot /mnt rm -r /etc/calamares
    chroot /mnt ln -s /usr/share/tuxedo/calamares-oem /etc/calamares
    chroot /mnt calamares
}

finished_task() {
    if kdialog --title "$title_finish" --yesno "<p align="center">$text_finish</p>" 2>/dev/null
        then
        systemctl reboot
    else
	umount -R /mnt
	sleep 1
        vgchange -a n system
        cryptsetup luksClose crypt_dev_${device}${part}${pnum3}
        exit
    fi
}
info_1() {
    length1=${#crypt_part_sizeg}
    length2=${#root_part_size}
    space1=""
    space2=""
    if [ "$length1" -eq 2 ]; then
	space1=" "
    elif [ "$length1" -eq 3 ]; then
	space1="  "
    elif [ "$length1" -eq 4 ]; then
	space1="   "
    fi
    if [ "$length2" -eq 2 ]; then
	space2=" "
    elif [ "$length2" -eq 3 ]; then
	space2="  "
    elif [ "$length2" -eq 4 ]; then
	space2="   "
    fi
    nvme=$(echo $device | grep nvm)
    if [ "$nvme" ]; then
        part="p"
    else
        part=""
    fi
    if [ "$llang" = de ]; then
	fs=ext4
	kdialog --title "Partitionen" --yesnocancel "<pre>Die folgenden Partitionen werden auf /dev/${device} erzeugt:	\n\n${device}${part}${pnum1}:		${space1}2.0	GB	 Boot \n${device}${part}${pnum2}:		${space1}0.5	GB	  EFI \n${device}${part}${pnum3}:		${crypt_part_sizeg}.0	GB	LUKS2 \n |\n |-system-root	${root_part_size}.0	GB	 ext4\n\nDie Systempartition wird standardmäßig mit ext4 formatiert.\nWenn sie das nicht möchten, wählen Sie im nächsten Dialog ein \nanderes Filesystem.\n\n</pre>" --yes-label "Akzeptieren und Weiter " --no-label "Filesystem ändern"
	case $? in
	    0)
		echo ""
		;;
	    1)
		fs=$(kdialog --combobox "Wählen Sie hier das Filesystem für die Ssystempartition." btrfs ext4 xfs --default btrfs --title "Filesystem")
		case $? in
		    0)
			echo ""
			;;
		    *)
			kdialog --sorry "Nichts gewählt, beende." --title "Fehler" 
			exit 0
			;;
		esac
		;;
	    *)
		exit 0
		;;
	esac
    else
	fs=ext4
	kdialog --title "Partitions" --yesnocancel "<pre>The following partitions will be created on /dev/${device}:	\n\n${device}${part}${pnum1}:		${space1}2.0	GB	 Boot \n${device}${part}${pnum2}:		${space1}0.5	GB	  EFI \n${device}${part}${pnum3}:		${crypt_part_sizeg}.0	GB	LUKS2 \n |\n |-system-root	${root_part_size}.0	GB	 ext4\n\\nThe system partition is formatted with ext4 by default.\nIf you prefer a different filesystem, choose another option \nin the next dialog.\n\n</pre>" --yes-label "Accept and continue" --no-label "Change filesystem"
	case $? in
	    0)
		echo ""
		;;
	    1)
		fs=$(kdialog --combobox "Select the file system for the system partition here." btrfs ext4 xfs --default btrfs --title "Filesystem")
		case $? in
		    0)
			echo ""
			;;
		    *)
			kdialog --sorry "Nothing selected, quit." --title "Error"
			exit 0
			;;
		esac
		;;
	    *)
		exit 0
		;;
	esac
    fi
}

check_memory 2>/dev/null
check_efi 2>/dev/null
check_crypt 2>/dev/null
find_device 2>/dev/null
check_free 2>/dev/null
check_fastboot 2>/dev/null
check_bitlock 2>/dev/null
count_part 2>/dev/null
use_full
generate_sizes 2>/dev/null

if [ "$fd_install" = 1 ];then
    parts=0
    size_fd
    echo "Partsize: " $part_sizeg
    info_1
    luks_passwd
    prepare_disk_full |  zenity --progress --title="$title_part_zenity" --pulsate --no-cancel --width=400 --auto-close
else
    if [ "$bitlock" ] && [ ! "$space" ]; then
	kdialog --title "$title_bitlock" --sorry "$text_bitlock" 2>/dev/null
	exit 0
    fi
    if [ "$fastboot" ] && [ ! "$space" ]; then
	kdialog --title "Problem!" --sorry "$text_fastboot" 2>/dev/null
	exit 0
    fi
    if [ ! "$space" ] && [ "$parts" ]; then
	echo "Platz? " $space
	echo "Partitionen? " $parts
	kdialog --title "$title_nspace" --warningyesno "$text_nspace1/dev/${device} $text_nspace2$text_nspace3" --yes-label "$pj" 2>/dev/null
	case $? in
	    0)
		dbus-launch partitionmanager --device /dev/$device 2>/dev/null
		check_free
		generate_sizes
		count_part
		if [ -z "$space" ]; then
		    kdialog --title "$title_npart" --msgbox "$text_npart" 2>/dev/null
		exit 0
		fi
		;;
	    *)
		kdialog --title "$title_npart" --msgbox "$text_npart" --ok-label "$ok1" 2>/dev/null
		exit 0
		;;
	esac
    fi
    info_1
    luks_passwd
    prepare_disk_along |  zenity --progress --title="$title_part_zenity" --pulsate --no-cancel --width=400 --auto-close
fi
prepare_target
check_mounts
rsync_task | zenity --progress --title="$title_rsync_zenity" --text="$text_rsync_zenity" --pulsate --no-cancel --width=400 --auto-close
calamares_task
finished_task
